﻿//
// Copyright 2004 Elvis Mehmedovic.
// http://emehmedovic.com/
//

// ScrollbarPaneButtonComponent

import xm.components.SimplePaneComponent;

class xm.components.AdminButtonComponent extends SimplePaneComponent {
	
	[Event("click")]
	[Event("enable")]
	[Event("disable")]
	
	private var __caption:String = "Untitled";
	private var __enabled:Boolean = true;

	[Inspectable()]
	var defaultButton:Boolean = false;
	
	[Inspectable(defaultValue=true)]
	function get enabled():Boolean {
		return __enabled;
	}
	
	function set enabled(p_enabled:Boolean) {
		__enabled = p_enabled;
		tabEnabled = p_enabled;
		dispatchEvent({type: p_enabled ? "enable" : "disable"});
		
	}
	
	[Inspectable()]
	function get caption():String {
		return __caption;
	}
	
	function set caption(p_caption:String) {
		__caption = p_caption;
		Aligner.updateAll();		
	}
	
	function AdminButtonComponent() {
	}

	function init(Void):Void {
		
		super.init();
		
		addEventListener("click", this);
		addEventListener("enable", this);
		addEventListener("disable", this);
		
		Key.addListener(this);
		
	}
	
	function onKeyDown(Void):Void {
		if (enabled && !_global.globalKeyboardLock && (Key.getCode() == Key.ENTER || Key.getCode() == Key.SPACE)) {
			if (Selection.getFocus() == String(this)) {
				onRelease();
			}
			else if (tabEnabled && defaultButton && eval(Selection.getFocus()).constructor == TextField && Key.getCode() == Key.ENTER) {
				for (var p = this._parent; p; p = p._parent) {
					if (p.tabChildren === false) {
						return;
					}
				}
				//Selection.setFocus(this);
				onRelease();
			}
		}
	}
	
	function onRelease(Void):Void {
		if (enabled) {
			dispatchEvent({type: "click"});
		}
	}

}
