﻿//
// Copyright 2004 Elvis Mehmedovic.
// http://emehmedovic.com/
//

import xm.components.SimplePaneComponent;

class xm.components.AdminTextFieldComponent extends SimplePaneComponent {
	
	[Event("focused")]
	[Event("editable")]
	[Event("notEditable")]
	
	var _this:Object;
	
	var tf:TextField;
	var tf_value:TextField;
	var tf_label:TextField;
	var bg:MovieClip;

	private var __label:String;
	private var __value:String;
	private var __enabled:Boolean;
	private var __editableField:Boolean;
	private var __labelWidth:Number;
	
	function setFocus(Void):Void {
		Selection.setFocus(tf_value);
		if (editableField) {
			dispatchEvent({type: eval(Selection.getFocus()) == tf_value ? "focused" : "editable"});
		}
		else {
			dispatchEvent({type: "notEditable"});
		}
	}

	[Inspectable(defaultValue=true)]
	function get enabled():Boolean {
		return __enabled;
	}
	
	function set enabled(p_enabled:Boolean) {
		__enabled = p_enabled;
		tabEnabled = p_enabled;
		dispatchEvent({type: p_enabled ? "enable" : "disable"});
	}

	[Inspectable(defaultValue=true)]
	function get editableField():Boolean {
		return __editableField;
	}
	
	function set editableField(p_editableField:Boolean) {
		__editableField = p_editableField;
		tf_value.type = p_editableField ? "input" : "dynamic";
		if (p_editableField) {
			dispatchEvent({type: eval(Selection.getFocus()) == tf_value ? "focused" : "editable"});
		}
		else {
			dispatchEvent({type: "notEditable"});
		}
	}
	
	[Inspectable(defaultValue=0)]
	function get labelWidth():Number {
		return __labelWidth;
	}
	
	function set labelWidth(p_labelWidth:Number) {
		__labelWidth = p_labelWidth;
		realign();
	}
	
	function realign(Void):Void {
		if (!width) {
			return;
		}
		
		var w:Number;
		
		if (labelWidth == 0) {
			tf_label.autoSize = true;
			w = Math.round(tf_label._width + 7 + 5);
		}
		else {
			w = Math.round(labelWidth);
			tf_label.autoSize = false;
			tf_label._width = w - 7 - 3;
		}

		
		bg.l._width = w;
		bg.r._x = w;
		bg.r._width = width - w;
		tf_value._x = w + 3;
		tf_value._width = width - w - 6;
	}
	
	[Inspectable()]
	function get label():String {
		return __label;
	}
	
	function set label(p_label:String) {
		__label = p_label;
	}
	
	[Inspectable()]
	function get value():String {
		return __value;
	}
	
	function set value(p_value:String) {
		//__value = p_value;
		if (p_value == undefined) {
			return;
		}
		tf_value.text = p_value;
		tf_value.onChanged();
	}
	
	function AdminTextFieldComponent() {
	}
	
	function resize(Void):Void {
		realign();
	}
	
	function _onKillFocus(Void):Void {
		if (_this.editableField) {
			_this.dispatchEvent({type: "editable"});
		}
	}

	function _onSetFocus(Void):Void {
		if (_this.editableField) {
			_this.dispatchEvent({type: "focusedEditable"});
		}
	}
	
	function _onChanged(Void):Void {
		_this._parent.onChanged(_this.tf_value);
	}
	
	function init(Void):Void {
		
		super.init();
		
		addEventListener("focusedEditable", this);
		addEventListener("editable", this);
		addEventListener("notEditable", this);
		addEventListener("resize", this);
		
		realign();
		
		tf_value.onSetFocus = _onSetFocus;
		tf_value.onKillFocus = _onKillFocus;
		tf_value.onChanged = _onChanged;
		
		tf_value._this = this;
		tf = tf_value;
		
	}


}
