﻿/*

The MIT License

Copyright (c) 2005-2008 Elvis Mehmedović

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

http://emehmedovic.com/

*/

import xm.corpus.resizableComponent;

class xm.components.GenericScrollbarClient extends resizableComponent {
	
	var scrollbarClient:Boolean = true;
	
	var contentX:Number;
	var contentY:Number;
	var contentHeight:Number;
	var contentWidth:Number;
	
	private var oldHeight:Number;
	private var oldWidth:Number;
	private var oldContentHeight:Number;
	private var oldContentWidth:Number;
	
	function GenericScrollbarClient() {
	}
	
	function init(Void):Void {
		super.init();
	}
	
	function get scroll():Number {
		return 1 - contentY;
	}
	
	function set scroll(p_val:Number):Void {
		contentY = 1 - Math.min(maxscroll, Math.max(1, p_val));
		update();
	}
	
	function get xhscroll():Number {
		return 1 - contentX;
	}
	
	function set xhscroll(p_val:Number):Void {
		contentX = 1 - Math.min(xmaxhscroll, Math.max(1, p_val));
		dispatchEvent({type: "onScroller"});
	}
	
	function get maxscroll():Number {
		return Math.max(1, contentHeight - height + 1);
	}
	
	function get xmaxhscroll():Number {
		return Math.max(1, contentWidth - width + 1);
	}
	
	function get bottomScroll():Number {
		return scroll + height - 1;
	}
	
	function get xrightScroll():Number {
		return xhscroll + width - 1;
	}
	
	function get textWidth():Number {
		return contentWidth - 5;
	}
	
	function addListener(p_obj:Object):Void {
		addEventListenerL("onScroller", p_obj, "onScroller");
	}
	
	function removeListener(p_obj:Object):Void {
		removeEventListenerL("onScroller", p_obj, "onScroller");
	}
	
	function update(Void):Void {
		oldContentWidth = contentWidth;
		oldContentHeight = contentHeight;
		oldWidth = width;
		oldHeight = height;
		dispatchEvent({type: "onScroller"});
	}
	
}