﻿//
// Copyright 2005 Elvis Mehmedovic.
// http://emehmedovic.com/
//

import xm.corpus.resizableComponent;
import xm.corpus.frameExecute;
import xm.components.MenuProperties;
import xm.components.MenuInteractionController;

class xm.components.MenuComponent extends resizableComponent {
	
	[IconFile("MenuComponent.png")]
	
	[Event("beforeSpawn")]
	[Event("afterSpawn")]
	[Event("removingSpawn")]
	
	[Event("beforeShow")]
	[Event("afterShow")]
	[Event("hide")]
	
	static var checkChar:String = "×";
	static var radioChar:String = "•";

	private var $fix, $sfix:Number;
	private var $dsId:Number;
	private var $daction:Number;
	private var $frameExecute:frameExecute;
	
	var fromItem:Number;
	var level:Number;
	
	var items:Array;
	
	var background:MovieClip;
	var holder:MovieClip;
	var spawned:MovieClip;
	
	var expanded:Boolean;
	
	var interactionController:MenuInteractionController;

	function MenuComponent() {
	}
	
	var menuProperties:MenuProperties;
	var spawnMenuProperties:MenuProperties;
	
	function getState(p_item:Number):Number {
		return holder[p_item]._currentframe - 2;
	}
	
	function refreshItem(p_item:Number, p_state:Number):Void {
		
		var tf:TextField = holder["l"+p_item];
		
		if ((expanded || interactionController.hasFocus) && p_state == 1 && fromItem == undefined && !menuProperties.forcePulldownBehavior) {
			p_state = 2;
		}
		
		holder[p_item].gotoAndStop(2 + p_state);
		if (items[p_item].pulldown && menuProperties.showArrow) {
			holder[p_item].arrow.gotoAndStop(2 + p_state);
		}
		
		tf._x = holder[p_item]._x + menuProperties.itemLeftMargin + menuProperties.textXOffsets[p_state];
		tf._y = holder[p_item]._y + menuProperties.itemTopMargin + menuProperties.textYOffsets[p_state];
		
		var tfo:TextFormat = items[p_item].enabled || items[p_item].enabled == undefined ? menuProperties.textFormats[p_state] : menuProperties.textFormats[3];
		tfo.tabStops = pdTabStops;
		tf.setNewTextFormat(tfo);
		tf.setTextFormat(tfo);
		
		if (items[p_item].pulldown && menuProperties.showArrow) {
			var arrow:MovieClip = holder[p_item].arrow;
			if (items[p_item].enabled || items[p_item].enabled == undefined) {
				arrow.gotoAndStop(2 + p_state);
			}
			else {
				arrow.gotoAndStop(5);
			}
			arrow._x = holder[p_item].width + menuProperties.arrowOffsetX + menuProperties.textXOffsets[p_state];
			arrow._y = Math.round(tf._height/2) + menuProperties.itemTopMargin + menuProperties.arrowOffsetY + menuProperties.textYOffsets[p_state];
		}
		
		if (items[p_item].symbol && menuProperties.showIcons) {
			var symbol:MovieClip = holder[p_item].symbol;
			if (items[p_item].enabled || items[p_item].enabled == undefined) {
				symbol.gotoAndStop(2 + p_state + (items[p_item].symbol-1) * 4);
			}
			else {
				symbol.gotoAndStop(5 + (items[p_item].symbol-1) * 4);
			}
			symbol._x = menuProperties.itemLeftMargin + menuProperties.textXOffsets[p_state] + menuProperties.symbolOffsetX;
			symbol._y = menuProperties.itemTopMargin + menuProperties.textYOffsets[p_state] + Math.round(tf._height/2) + menuProperties.symbolOffsetY;
		}
		
	}
	
	function removeSpawn(Void):Void {
		
		clearAllDelayed();
		
			// recur
			spawned.removeSpawn();
			// forced onUnload
			spawned.onUnload();
			delete spawned.onUnload;
		
		dispatchEvent({type: "removingSpawn", spawned: spawned});
		
		spawned.removeMovieClip();
		
		if (fromItem == undefined && !menuProperties.forcePulldownBehavior && getState(interactionController.lastItems[0]) == 2) {
			refreshItem(interactionController.lastItems[0], 1);
		}
		
	}
	
	function clearAllDelayed(Void):Void {
		for(var i:Number = 0; i < interactionController.menus.length; i++) {
			tellTarget(interactionController.menus[i]) {
				if ($dsId) {
					clearInterval($dsId);
				}
				$frameExecute.kill();
			}
		}
	}

	function delayedSpawn(p_item:Number):Void {
		
		if ($daction == p_item) {
			return;
		}
		
		clearAllDelayed();
		
		$daction = p_item;
		
		$dsId = setInterval(this, "frameSpawn", menuProperties.spawnDelay, arguments);
		
	}
	
	function frameSpawn(p_item:Number):Void {
		$frameExecute = new frameExecute(this, "spawn", arguments);
	}
	
	function spawn(p_item:Number):Void {
		
		var oldExpanded:Boolean = expanded;
		
		clearAllDelayed();
		expanded = true;
		interactionController.hasFocus = true;
		
		
		// bug in Flash...
			if (typeof p_item == "object") {
				p_item = p_item[0];
			}
			if (typeof spawned.fromItem == "object") {
				spawned.fromItem = spawned.fromItem[0];
			}
		
		if (spawned.fromItem == p_item) {
			return;
		}

		removeSpawn();
		
		if (!items[p_item].pulldown) {
			return;
		}

		if (level == 0) {
			refreshItem(p_item, menuProperties.forcePulldownBehavior ? 1 : 2);
		}
		
		dispatchEvent({type: "beforeSpawn"});
		
		$sfix = $sfix > 1000 || !$sfix ? 1 : $sfix + 1;
		
		// attach movie not returning reference? yet another quirk in Flash...
		attachMovie(spawnMenuProperties.spawnSymbol, "spawned"+$sfix, getNextHighestDepth(), { interactionController: interactionController, items: items[p_item].pulldown, menuProperties: items[p_item].menuProperties ? items[p_item].menuProperties : spawnMenuProperties, spawnMenuProperties: items[p_item].spawnMenuProperties ? items[p_item].spawnMenuProperties : spawnMenuProperties, fromItem: p_item } ); 
		spawned = this["spawned"+$sfix];
		
		if (!menuProperties.vertical) {
			var x:Number = holder[p_item]._x + menuProperties.spawnOffsetX + menuProperties.leftMargin;
			var y:Number = holder[p_item]._y + holder[p_item].height + menuProperties.topMargin + menuProperties.spawnOffsetY;
			
			var p:Object = {x: x, y: y};
			localToGlobal(p);
				
			spawned._x = spawned.pdWidth != undefined && p.x + spawned.pdWidth > Stage.width ? x + Stage.width - (p.x + spawned.pdWidth) - 1 : x;
			spawned._y = spawned.pdHeight != undefined && p.y + spawned.pdHeight > Stage.height ? 0 - spawned.pdHeight - menuProperties.spawnOffsetY : y;
		}
		else {
			var x:Number = holder[p_item]._x + holder[p_item].width + menuProperties.leftMargin + menuProperties.rightMargin + menuProperties.spawnOffsetX;
			var y:Number = holder[p_item]._y + menuProperties.topMargin + menuProperties.spawnOffsetY;
			
			var p:Object = {x: x, y: y};
			localToGlobal(p);
				
			spawned._x = spawned.pdWidth != undefined && p.x + spawned.pdWidth > Stage.width ? 0 - spawned.pdWidth - menuProperties.spawnOffsetX : x;
			spawned._y = spawned.pdHeight != undefined && p.y + spawned.pdHeight > Stage.height ? holder[p_item]._y - spawned.pdHeight - menuProperties.spawnOffsetY + menuProperties.topMargin + holder[p_item].height : y;
		}
		
		dispatchEvent({type: "afterSpawn", spawned: spawned, newSpawn: !oldExpanded});

		
	}

	var textWidth:Number;
	var textHeight:Number;
	
	var pdWidth:Number;
	var pdHeight:Number;
	
	var pdTabStops:Array;
	
	function getTextExtent(p_tfmt: TextFormat, p_text:String, p_embed:Boolean) {
		createTextField("$temp_tfmt", getNextHighestDepth(), 0, 0, 0, 0);
		var tf:TextField = this["$temp_tfmt"];
		tf.setNewTextFormat(p_tfmt);
		tf.embedFonts = p_embed;
		tf.autoSize = "left";
		tf.text = p_text;
		var w:Number = tf._width;
		var h:Number = tf._height;
		tf.removeTextField();
		return { height: h - 4, width: w - 4, textFieldHeight: h, textFieldWidth: w };
	}
	
	function calculateDimensions(Void):Void {
		
		if (menuProperties.customDimensions) {
			pdWidth = menuProperties.customDimensions.width;
			pdHeight = menuProperties.customDimensions.height;
			return;
		}
		
		var tf:TextFormat = menuProperties.textFormats[0];
		var twidth:Number = 0;
		var swidth:Number = 0;
		var h:Number = 0;
		
		textHeight = Math.max(10, getTextExtent(tf, "X", menuProperties.textFieldProperties.embedFonts).textFieldHeight);
		
		for (var i:Number = 0; i < items.length; i++) {
			if (i) {
				h += menuProperties.itemSpacing;
			}
			if (items[i].separator) {
				h += menuProperties.separatorHeight;
			}
			else {
				twidth = Math.max(getTextExtent(tf, items[i].caption, menuProperties.textFieldProperties.embedFonts).width, twidth);
				if (items[i].shortcut) {
					swidth = Math.max(getTextExtent(tf, items[i].shortcut, menuProperties.textFieldProperties.embedFonts).width, swidth);
				}
				h += textHeight + menuProperties.itemTopMargin + menuProperties.itemBottomMargin;
			}
		}
		
		textWidth = twidth + 4 + (menuProperties.showArrow ? menuProperties.arrowSpace : 0);
		
		pdTabStops = new Array();
		
		if (menuProperties.showIcons) {
			var space:Number = getTextExtent(tf, menuProperties.iconStrSpace, menuProperties.textFieldProperties.embedFonts).width + menuProperties.iconSpace;
			textWidth += space;
			pdTabStops.push(space);
		}
		if (menuProperties.showShortcuts) {
			var space:Number = getTextExtent(tf, menuProperties.shortcutStrSpace, menuProperties.textFieldProperties.embedFonts).width + menuProperties.shortcutSpace;
			textWidth += swidth + space;
			if (pdTabStops.length) {
				pdTabStops.push(pdTabStops[pdTabStops.length-1] + twidth + space);
			}
			else {
				pdTabStops.push(0);
				pdTabStops.push(pdTabStops[pdTabStops.length-1] + twidth + space);
			}
		}
		
		pdWidth = textWidth + menuProperties.leftMargin + menuProperties.rightMargin + menuProperties.itemLeftMargin + menuProperties.itemRightMargin;
		pdHeight = h + menuProperties.topMargin + menuProperties.bottomMargin;
		
	}
	
	function hide(Void):Void {
		//expanded = false;
		background.removeMovieClip();
		holder.removeMovieClip();
		interactionController.remove(this);
		dispatchEvent({type: "hide"});
	}
	
	function draw(Void):Void {
		
		dispatchEvent({type: "beforeShow"});
		
		removeSpawn();
		interactionController.remove(this);
		
		if (interactionController.menus.length == 0) {
			interactionController.closeAll();
			expanded = menuProperties.forcePulldownBehavior ? true : false;
		}
		else {
			expanded = true;
		}
		
		level = interactionController.register(this);
		
		var i:Number = 0;
		
		$fix = $fix > 1000 || !$fix ? 1 : $fix + 1;
		
		background.removeMovieClip();
		holder.removeMovieClip();
		
		delete __width;
		delete __height;
		delete $daction;
		
		attachMovie(menuProperties.backgroundSymbol, "background"+$fix, getNextHighestDepth(), { menu: this} );
		background = this["background"+$fix];
		
		if (!menuProperties.customDimensions) {
			Aligner.registerOnly(background, {hStretch: true, vStretch: true});
		}
		
		holder = createEmptyMovieClip("holder"+$fix, getNextHighestDepth());
		
		holder._x = menuProperties.leftMargin;
		holder._y = menuProperties.topMargin;
		
		if (menuProperties.vertical) {
			calculateDimensions()
			if (fromItem == undefined && menuProperties.forcePulldownBehavior) {
				var p:Object = {x: _x, y: _y};
				_parent.localToGlobal(p);
				
				if (p.x + pdWidth > Stage.width) {
					_x -= pdWidth;
				}
				if (p.y + pdHeight > Stage.height) {
					_y -= pdHeight;
				}
			}
		}
		
		var h:Number = 0;
		
		for (var i:Number = 0; i < items.length; i++) {
			
			if (i) {
				h += menuProperties.itemSpacing;
			}
			
			var t:String = items[i].caption;
			if (menuProperties.showIcons) {
				t = (items[i].char ? items[i].char : "") + chr(9) + t;
			}
			if (menuProperties.showShortcuts) {
				t += chr(9) + (items[i].shortcut ? items[i].shortcut : "");
			}
							
			if (menuProperties.vertical) {
				if (items[i].separator) {
					var item:MovieClip = holder.attachMovie(menuProperties.separatorSymbol, String(i), i+1, { __width: pdWidth, __height: menuProperties.separatorHeight } );
					item._x = -menuProperties.leftMargin;
					item._y = h;
					h += menuProperties.separatorHeight;
				}
				else {
					
					holder.createTextField("l"+i, 10000+i, 0, 0, 0, 0);
					var tf:TextField = holder["l"+i];
					
					tf.autoSize = "left";
					tf.selectable = false;
					
					for (var l:String in menuProperties.textFieldProperties) {
						tf[l] = menuProperties.textFieldProperties[l];
					}
					
					tf.text = t;
					
					if (menuProperties.forceTightFit) {
						refreshItem(i, 0);
					}
					
					var item:MovieClip = holder.attachMovie(menuProperties.itemSymbol, String(i), i+1, { __width: (menuProperties.forceTightFit ? tf._width + menuProperties.itemLeftMargin + menuProperties.itemRightMargin : pdWidth - (menuProperties.leftMargin + menuProperties.rightMargin)), __height: textHeight + menuProperties.itemTopMargin + menuProperties.itemBottomMargin, interactionController: interactionController } );
						
					item.onRollOut = _onRollOut;
					item._y = h;
					h += textHeight + menuProperties.itemTopMargin + menuProperties.itemBottomMargin;
					
					refreshItem(i, 0);
						
				}
			}
			else {
				holder.createTextField("l"+i, 10000+i, 0, 0, 0, 0);
				var tf:TextField = holder["l"+i];
					
				tf.autoSize = "left";
				tf.selectable = false;

				for (var l:String in menuProperties.textFieldProperties) {
					tf[l] = menuProperties.textFieldProperties[l];
				}
				
				refreshItem(i, 0);
				tf.text = t;

				if (items[i].separator) {
					var item:MovieClip = holder.attachMovie(menuProperties.separatorSymbol, String(i), i+1, { __width: menuProperties.separatorWidth, __height: tf._height + menuProperties.itemTopMargin + menuProperties.itemBottomMargin} );
					item._y = h;
					h += menuProperties.separatorWidth;
					tf.removeTextField();
				}
				else {
					var item:MovieClip = holder.attachMovie(menuProperties.itemSymbol, String(i), i+1, { __width: tf._width + menuProperties.itemLeftMargin + menuProperties.itemRightMargin, __height: tf._height + menuProperties.itemTopMargin + menuProperties.itemBottomMargin, interactionController: interactionController} );
					item.onRollOut = _onRollOut;
					item._x = h;
					h += item.width;
						
					refreshItem(i, 0);
				}
			}
			
		}
		
		if (!menuProperties.vertical) {
			setSize(h + menuProperties.leftMargin + menuProperties.rightMargin, holder[0].height + menuProperties.topMargin + menuProperties.bottomMargin);
		}
		else {
			setSize(pdWidth, pdHeight);
		}
		
		interactionController.justCreated = true;
		
		dispatchEvent({type: "afterShow"});
		
	}
	
	function _onRollOut(Void):Void {
		interactionController.rolledOut();
	}
	
	function onUnload(Void):Void {
		interactionController.menus[0].dispatchEvent({type: "unload"});
		
		clearAllDelayed();
		interactionController.remove(this);
	}

	function init(Void):Void {
		
		super.init();
		nextFrame();
		
		if (!interactionController) {
			interactionController = new MenuInteractionController();
		}
		
		if (!menuProperties) {
			menuProperties = new MenuProperties ();
		}
		if (!spawnMenuProperties) {
			spawnMenuProperties = new MenuProperties ( {vertical: true} );
		}
		
		if (!items) {
			items = new Array();
		}
		else {
			draw();
		}
		
	}

}